﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: true
#End Region

Sub Process_Globals
	Public appliactive As Boolean	= False					'flag when application is active
	Public mqttlog As String							' flag to stog log of MQTT messages
	Public mqttmessage As Boolean = False				' true = new message received
	Public mqttalarm As Boolean = False					' true = new alarm to highlignt
	Public mqttstatus As String = "MQTT not connected"	' MQTT status
	Public mqttworking As Boolean = False           	'start of MQTT after config loaded
	Private nid As Int = 1
	Private mqtt As MqttClient
	Private lock As PhoneWakeState
	Private timer1 As Timer
	Private timernb As Byte = 0
	Private mqttserver As String = "host"
	Private mqttport As String = "port"
	Private mqttuser As String = "user"
	Private mqttpwd As String  = "pasword"
	Private mqttsubs As String = "subscribe"
	Private SOScode1 As String = "654321"
	Private SOScode2 As String = "123456"
	Private SOSsound As String = "8499.mp3"
End Sub

Sub Service_Create
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	Service.StartForeground(nid, CreateNotification("...",False))
	Log("create service")
End Sub

Sub Service_Start (StartingIntent As Intent)
	lock.PartialLock
	CancelScheduledService(Me)
	Service.StopAutomaticForeground
	timer1.Initialize("timer1", 15000)
	timer1.Enabled = True
	Log("start service " & DateTime.time(DateTime.Now))
	Sleep(500)
	MQTTConnect
End Sub

Sub MQTTConnect
 	service_loadconfig
	If mqttworking = True Then
		If mqtt.IsInitialized Then mqtt.Close
'			Log(mqttserver&":"&mqttport)
		mqtt.Initialize("mqtt",(mqttserver&":"&mqttport), Rnd(0, 999999999 & DateTime.Now))
		Dim mo As MqttConnectOptions
		mo.Initialize(mqttuser, mqttpwd)
		Log("Trying to connect")
		mqttstatus ="Trying to connect"
		mqtt.Connect2(mo)
		Wait For mqtt_Connected (Success As Boolean)
		If Success Then
			mqtt.Subscribe(mqttsubs, 0)
			Log("Mqtt connected")
			mqttstatus = "MQTT connected"
			Sleep(1000)
			mqtt_publish("request alarms")
		Else	
			Log("error MQTT connection")
			mqttstatus = "MQTT connection error"
		End If
	Else	
		mqttstatus = "MQTT data error"
	End If
End Sub

'Sub mqtt_Connected (Success As Boolean)
'	Log( "action when mqtt_Connected")
'End Sub

'Sub mqtt_Disconnected
'	'mqttstatus = "MQTT disconnected"
'End Sub

public Sub mqtt_publish(body As String)     '(topic As String,body As String)
	Dim payload() As Byte
	Dim topic As String
	topic = "cmnd/rfgate"
   	payload = body.getbytes("UTF8")
   	If mqtt.Connected = True Then 
    	mqtt.Publish(topic, payload)	
		Log("publish: topic="& topic &" payload=" & body)
	End If
End Sub

Sub mqtt_MessageArrived (Topic As String, Payload() As Byte)
	Dim s As String= BytesToString(Payload,0,Payload.Length,"UTF-8")
	Log("Topic:" & Topic & " payload:" & s)
	If s.Contains(SOScode1) Or s.Contains(SOScode2) Then
	    mqttalarm = True
		Dim n As Notification = CreateNotification(s,True)
		n.Notify(nid)		
'		Service.StartForeground(nid,CreateNotification(" SOS alarme",True))
		Sleep( 2000)
	Else
		mqttalarm= False	
	End If
		If (mqttlog.Length > 1000) Then mqttlog = mqttlog.SubString2(1,mqttlog.lastIndexOf(Chr(10)))
		' we remove one line at log file
	mqttlog= DateTime.time(DateTime.Now) &" " & s & CRLF & mqttlog
		mqttmessage = True	
	If appliactive = False Then serviceclose
End Sub

 Sub service_loadconfig
	If File.Exists(File.DirInternal,"config.txt") Then
		Dim tr As TextReader
		Dim line As String
		tr.Initialize2(File.OpenInput(File.Dirinternal, "config.txt"), "UTF-8" )
		mqttserver = "tcp://"&tr.ReadLine
		mqttport   = tr.ReadLine
		mqttuser   = tr.ReadLine
		mqttpwd    = tr.ReadLine
		mqttsubs   = tr.ReadLine
		SOScode1   = tr.ReadLine
		SOScode2   = tr.ReadLine
		SOSsound   = tr.ReadLine
		mqttworking = True
		Log("read OK")
	Else
		mqttworking = False
		Log("read NOK")
		ToastMessageShow("MQTT IP config NOK...", True)
	End If
	If Not (File.Exists(File.DirAssets,SOSsound)) Then SOSsound = "8499.mp3"
End Sub

Sub Timer1_Tick     
	'case service active/ on stop le service
	If appliactive = False Then
		serviceclose
	Else
		timernb = timernb + 1
		If timernb = 4 Then			'1mn
			If mqtt.Connected = False  Then
				Log(" new connect")
				 MQTTConnect
			Else
				Log(" new publish")
				mqtt_publish("request alarms")
				timernb = 0
			End If
		End If
	End If
End Sub

Sub serviceclose
	CancelScheduledService(Me) '"")
	If mqtt.IsInitialized Then mqtt.Close
	lock.ReleasePartialLock
	timer1.Enabled = False
	StartServiceAt("",DateTime.Now + 60000,True)
	Log("init next start OK")
	StopService(Me)
End Sub

Sub CreateNotification (Body As String, Sound As Boolean) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_HIGH)
	notification.Icon = "icon"
	notification.Sound = Sound
	notification.vibrate = False
	notification.SetInfo("Tracking SOS Alertes", Body, Main)
	Return notification
End Sub

Sub Service_Destroy
	mqttstatus = "MQTT in pause"
	lock.ReleasePartialLock
	Log("service stop")
End Sub
